diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
similarity index 96%
rename from src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
rename to src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
index 5f48a3708..8d5edbd90 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.achievements.pages;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.achievements.AchievementsScreen;
+import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.achievements.data.AchievementPage;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -19,13 +19,13 @@ import org.jetbrains.annotations.Nullable;
 import java.util.Random;
 import java.util.function.BiFunction;
 
-public class OverworldPage extends AchievementPage {
+public class AchievementPageOverworld extends AchievementPage {
     protected final Minecraft mc = Minecraft.getMinecraft(this);
     protected final ItemStack icon;
     @NotNull
     protected final String key;
 
-    public OverworldPage(String key, ItemStack icon) {
+    public AchievementPageOverworld(String key, ItemStack icon) {
         this.key = key;
         this.icon = icon;
     }
@@ -57,7 +57,7 @@ public class OverworldPage extends AchievementPage {
     protected static final Block[] BASALT_ORES = new Block[]    { Blocks.ORE_COAL_BASALT,   Blocks.ORE_IRON_BASALT,     Blocks.ORE_GOLD_BASALT,     Blocks.ORE_DIAMOND_BASALT,      Blocks.ORE_REDSTONE_BASALT,     Blocks.ORE_LAPIS_BASALT};
 
     @Override
-    public IconCoordinate getBackgroundTile(AchievementsScreen screen, int layer, Random random, int tileX, int tileY) {
+    public IconCoordinate getBackgroundTile(ScreenAchievements screen, int layer, Random random, int tileX, int tileY) {
         random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
         // expect x range from  0  to 45
         // expect y range from -12 to 50
@@ -96,7 +96,7 @@ public class OverworldPage extends AchievementPage {
     }
 
     @Override
-    public void postProcessBackground(AchievementsScreen screen, Random random, AchievementsScreen.BGLayer layer, int orgX, int orgY) {
+    public void postProcessBackground(ScreenAchievements screen, Random random, ScreenAchievements.BGLayer layer, int orgX, int orgY) {
         random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
         if (layer.id == 0) {
 
@@ -194,7 +194,7 @@ public class OverworldPage extends AchievementPage {
         }
     }
 
-    protected void carveCircle(AchievementsScreen screen, AchievementsScreen.BGLayer layer, int centerX, int centerY, int radius){
+    protected void carveCircle(ScreenAchievements screen, ScreenAchievements.BGLayer layer, int centerX, int centerY, int radius){
         for (int i = centerX - radius; i <= centerX + radius ; i++) {
             for (int j = centerY - radius; j < centerY + radius; j++) {
                 double diffX = (i + 0.5) - centerX;
@@ -206,12 +206,12 @@ public class OverworldPage extends AchievementPage {
         }
     }
 
-    protected void placeStructure(AchievementsScreen screen, PageStructure structure, int tileX, int tileY, @Nullable BiFunction<IconCoordinate, IconCoordinate, IconCoordinate> coordinateProcessor) {
+    protected void placeStructure(ScreenAchievements screen, PageStructure structure, int tileX, int tileY, @Nullable BiFunction<IconCoordinate, IconCoordinate, IconCoordinate> coordinateProcessor) {
         if (coordinateProcessor == null) {
             coordinateProcessor = (i, i2) -> i;
         }
         for (int layer = 0; layer < structure.layers; layer++) {
-            AchievementsScreen.BGLayer cache = screen.getLayer(layer);
+            ScreenAchievements.BGLayer cache = screen.getLayer(layer);
             if (cache != null) {
                 for (int _x = 0; _x < structure.width; _x++) {
                     for (int _y = 0; _y < structure.height; _y++) {
diff --git a/src/main/java/net/minecraft/client/gui/chat/ChatEmotePickerElement.java b/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
similarity index 95%
rename from src/main/java/net/minecraft/client/gui/chat/ChatEmotePickerElement.java
rename to src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
index 261302c7f..ab644a0eb 100644
--- a/src/main/java/net/minecraft/client/gui/chat/ChatEmotePickerElement.java
+++ b/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
@@ -8,12 +8,12 @@ import net.minecraft.core.net.ChatEmotes;
 
 import java.util.Map;
 
-public class ChatEmotePickerElement extends Gui {
+public class GuiElementChatEmotePicker extends Gui {
     private static final int CELL_WIDTH = 16;
     private static final int CELL_HEIGHT = 16;
 
     private final Minecraft mc;
-    private final ChatScreen parent;
+    private final ScreenChat parent;
 
     private final int width;
     private final int height;
@@ -26,7 +26,7 @@ public class ChatEmotePickerElement extends Gui {
 
     private int scroll = 0;
 
-    public ChatEmotePickerElement(Minecraft mc, ChatScreen parent, int xCells, int yCells) {
+    public GuiElementChatEmotePicker(Minecraft mc, ScreenChat parent, int xCells, int yCells) {
         this.mc = mc;
         this.parent = parent;
 
diff --git a/src/main/java/net/minecraft/client/gui/chat/ChatSuggestionsElement.java b/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
similarity index 99%
rename from src/main/java/net/minecraft/client/gui/chat/ChatSuggestionsElement.java
rename to src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index 02e6e6563..9607f5302 100644
--- a/src/main/java/net/minecraft/client/gui/chat/ChatSuggestionsElement.java
+++ b/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -37,7 +37,7 @@ import java.util.Optional;
 import java.util.concurrent.CompletableFuture;
 
 @SuppressWarnings({"OptionalGetWithoutIsPresent", "unused"})
-public class ChatSuggestionsElement extends Gui {
+public class GuiElementChatSuggestions extends Gui {
     private final TextFieldEditor editor;
     private final ITextField textField;
     private final Minecraft mc;
@@ -71,7 +71,7 @@ public class ChatSuggestionsElement extends Gui {
 
     public boolean hidden = false;
 
-    public ChatSuggestionsElement(Minecraft mc, TextFieldEditor textFieldEditor, ITextField textField, PositionSupplier<Integer> xSupplier, PositionSupplier<Integer> ySupplier, ComponentAnchor anchor) {
+    public GuiElementChatSuggestions(Minecraft mc, TextFieldEditor textFieldEditor, ITextField textField, PositionSupplier<Integer> xSupplier, PositionSupplier<Integer> ySupplier, ComponentAnchor anchor) {
         this.mc = mc;
         this.xSupplier = xSupplier;
         this.ySupplier = ySupplier;
diff --git a/src/main/java/net/minecraft/client/gui/chat/ChatScreen.java b/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
similarity index 92%
rename from src/main/java/net/minecraft/client/gui/chat/ChatScreen.java
rename to src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
index 64b323481..e1dfdfe40 100644
--- a/src/main/java/net/minecraft/client/gui/chat/ChatScreen.java
+++ b/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
@@ -3,7 +3,6 @@ package net.minecraft.client.gui.chat;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.text.TextFieldEditor;
-import net.minecraft.client.render.Font;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import org.lwjgl.input.Keyboard;
@@ -11,22 +10,22 @@ import org.lwjgl.input.Keyboard;
 import net.minecraft.client.gui.text.ITextField;
 import org.lwjgl.input.Mouse;
 
-public class ChatScreen extends Screen implements ITextField {
+public class ScreenChat extends Screen implements ITextField {
 
 	protected String message;
 	private int currentIndex = 0;
 	private String originalMessage;
 	private int updateCounter;
 	private final TextFieldEditor editor;
-	protected ChatEmotePickerElement emotePicker;
+	protected GuiElementChatEmotePicker emotePicker;
 	protected boolean showEmotePicker = false;
-	private ChatSuggestionsElement suggestionsElement;
+	private GuiElementChatSuggestions suggestionsElement;
 
-	public ChatScreen() {
+	public ScreenChat() {
 		this("");
 	}
 
-	public ChatScreen(String initialMessage) {
+	public ScreenChat(String initialMessage) {
 		message = initialMessage;
 		updateCounter = 0;
 		editor = new TextFieldEditor(this);
@@ -37,9 +36,9 @@ public class ChatScreen extends Screen implements ITextField {
 	public void init() {
 		Keyboard.enableRepeatEvents(true);
 		int emotePickerYCells = (int)MathHelper.clamp(Math.ceil(ChatEmotes.getEmotes().size() / 5.0), 0, 4);
-		emotePicker = new ChatEmotePickerElement(mc, this, 5, emotePickerYCells);
+		emotePicker = new GuiElementChatEmotePicker(mc, this, 5, emotePickerYCells);
 		showEmotePicker = false;
-		suggestionsElement = new ChatSuggestionsElement(
+		suggestionsElement = new GuiElementChatSuggestions(
 			mc,
 			editor,
 			this,
@@ -58,7 +57,7 @@ public class ChatScreen extends Screen implements ITextField {
 	@Override
 	public void removed() {
 		Keyboard.enableRepeatEvents(false);
-		mc.ingameHud.chatScroll = 0;
+		mc.hudIngame.chatScroll = 0;
 	}
 
 	@Override
@@ -71,7 +70,7 @@ public class ChatScreen extends Screen implements ITextField {
 			if (showEmotePicker) {
 				emotePicker.scrollOffset((int)(-dWheel / 0.1f));
 			} else {
-				mc.ingameHud.chatScroll += dWheel;
+				mc.hudIngame.chatScroll += dWheel;
 			}
 		}
 
@@ -138,7 +137,7 @@ public class ChatScreen extends Screen implements ITextField {
 				handled = true;
 			}
 		}
-		if (eventKey == Keyboard.KEY_ESCAPE && !(this instanceof SleepScreenMP)) {
+		if (eventKey == Keyboard.KEY_ESCAPE && !(this instanceof ScreenSleepMP)) {
 			mc.displayScreen(null);
 			handled = true;
 		}
diff --git a/src/main/java/net/minecraft/client/gui/chat/SleepScreenMP.java b/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
similarity index 80%
rename from src/main/java/net/minecraft/client/gui/chat/SleepScreenMP.java
rename to src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
index a6afc0f4c..bc8a452aa 100644
--- a/src/main/java/net/minecraft/client/gui/chat/SleepScreenMP.java
+++ b/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
@@ -1,18 +1,18 @@
 package net.minecraft.client.gui.chat;
 
-import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
+import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.net.handler.ClientPacketHandler;
+import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.core.net.packet.UpdatePlayerStatePacket;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 
-public class SleepScreenMP extends ChatScreen
+public class ScreenSleepMP extends ScreenChat
 {
 
-    public SleepScreenMP()
+    public ScreenSleepMP()
     {
     }
 
@@ -23,7 +23,7 @@ public class SleepScreenMP extends ChatScreen
         I18n i18n = I18n.getInstance();
         buttons.add(new ButtonElement(1, width / 2 - 100, height - 40, i18n.translateKey("gui.sleeping.multiplayer.leave_bed")));
 		int emotePickerYCells = (int)MathHelper.clamp(Math.ceil(ChatEmotes.getEmotes().size() / 5.0), 0, 4);
-		emotePicker = new ChatEmotePickerElement(mc, this, 5, emotePickerYCells);
+		emotePicker = new GuiElementChatEmotePicker(mc, this, 5, emotePickerYCells);
 		showEmotePicker = false;
         super.init();
     }
@@ -62,9 +62,9 @@ public class SleepScreenMP extends ChatScreen
 
     private void leaveBed()
     {
-        if(mc.thePlayer instanceof MultiplayerLocalPlayer)
+        if(mc.thePlayer instanceof PlayerLocalMultiplayer)
         {
-            ClientPacketHandler sendQueue = ((MultiplayerLocalPlayer)mc.thePlayer).sendQueue;
+            PacketHandlerClient sendQueue = ((PlayerLocalMultiplayer)mc.thePlayer).sendQueue;
             sendQueue.addToSendQueue(new UpdatePlayerStatePacket(UpdatePlayerStatePacket.STATE_LEAVE_BED));
         }
     }
diff --git a/src/main/java/net/minecraft/client/gui/container/ActivatorScreen.java b/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
similarity index 68%
rename from src/main/java/net/minecraft/client/gui/container/ActivatorScreen.java
rename to src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
index a5cc2d3f6..4f2ecc8fb 100644
--- a/src/main/java/net/minecraft/client/gui/container/ActivatorScreen.java
+++ b/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
@@ -1,26 +1,24 @@
 package net.minecraft.client.gui.container;
 
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.inventory.container.Inventory;
-import net.minecraft.core.player.inventory.menu.ActivatorMenu;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.player.inventory.menu.MenuActivator;
 import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.util.helper.Listener;
 import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class ActivatorScreen extends AbstractContainerScreen {
-    protected final ActivatorBlockEntity activatorBlockEntity;
+public class ScreenActivator extends ScreenContainerAbstract {
+    protected final TileEntityActivator tileEntityActivator;
     protected final List<ButtonElement> slotButtons = new ArrayList<>();
 
-    public ActivatorScreen(Inventory inventory, ActivatorBlockEntity activatorBlock) {
-        super(new ActivatorMenu(inventory, activatorBlock));
-        this.activatorBlockEntity = activatorBlock;
+    public ScreenActivator(ContainerInventory inventory, TileEntityActivator activatorBlock) {
+        super(new MenuActivator(inventory, activatorBlock));
+        this.tileEntityActivator = activatorBlock;
     }
 
     @Override
@@ -32,7 +30,7 @@ public class ActivatorScreen extends AbstractContainerScreen {
         final int startY = yTop + 34;
         buttons.clear();
         slotButtons.clear();
-        for (int i = 0; i < activatorBlockEntity.getContainerSize(); i++) {
+        for (int i = 0; i < tileEntityActivator.getContainerSize(); i++) {
             ButtonElement button = new ButtonElement(i, startX + 18 * i, startY, 18, 18, "");
             button.visible = false;
             slotButtons.add(button);
@@ -43,7 +41,7 @@ public class ActivatorScreen extends AbstractContainerScreen {
     public void clickInventory(int x, int y, int mouseButton) {
         if (mouseButton == 1 && mc.thePlayer.inventory.getHeldItemStack() == null) {
             for (ButtonElement button : slotButtons) {
-                if (activatorBlockEntity.getItem(button.id) == null && button.mouseClicked(mc, x, y)) {
+                if (tileEntityActivator.getItem(button.id) == null && button.mouseClicked(mc, x, y)) {
                     mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.LOCK, new int[] {button.id, 0}, mc.thePlayer);
                     if (button.playSound) {
                         mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
@@ -69,10 +67,10 @@ public class ActivatorScreen extends AbstractContainerScreen {
         int yTop = (height - ySize) / 2;
         drawTexturedModalRect(xLeft, yTop, 0, 0, xSize, ySize);
 
-        if (!activatorBlockEntity.locked(activatorBlockEntity.stackSelector)) { // Draw selector arrow
+        if (!tileEntityActivator.locked(tileEntityActivator.stackSelector)) { // Draw selector arrow
             final int startX = xLeft + 7;
             final int startY = yTop + 26;
-            drawTexturedModalRect( startX + 18 * activatorBlockEntity.stackSelector, startY, 176, 0, 18, 34);
+            drawTexturedModalRect( startX + 18 * tileEntityActivator.stackSelector, startY, 176, 0, 18, 34);
         }
     }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/gui/container/ContainerScreen.java b/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
similarity index 87%
rename from src/main/java/net/minecraft/client/gui/container/ContainerScreen.java
rename to src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
index 86d38a502..2f28a2123 100644
--- a/src/main/java/net/minecraft/client/gui/container/ContainerScreen.java
+++ b/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui.container;
 
-import net.minecraft.core.player.inventory.menu.ContainerMenu;
+import net.minecraft.core.player.inventory.menu.MenuContainer;
 import net.minecraft.core.player.inventory.container.Container;
 import org.lwjgl.opengl.GL11;
 
@@ -8,12 +8,12 @@ import org.lwjgl.opengl.GL11;
 //            GuiContainer, ContainerChest, IInventory, FontRenderer, 
 //            RenderEngine
 
-public class ContainerScreen extends AbstractContainerScreen
+public class ScreenContainer extends ScreenContainerAbstract
 {
 
-    public ContainerScreen(Container containerUpper, Container containerLower)
+    public ScreenContainer(Container containerUpper, Container containerLower)
     {
-        super(new ContainerMenu(containerUpper, containerLower));
+        super(new MenuContainer(containerUpper, containerLower));
         inventoryRows = 0;
         upperChestInventory = containerUpper;
         lowerChestInventory = containerLower;
diff --git a/src/main/java/net/minecraft/client/gui/container/AbstractContainerScreen.java b/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
similarity index 85%
rename from src/main/java/net/minecraft/client/gui/container/AbstractContainerScreen.java
rename to src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index 44adc4f96..12e9c86a0 100644
--- a/src/main/java/net/minecraft/client/gui/container/AbstractContainerScreen.java
+++ b/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -2,19 +2,18 @@
 package net.minecraft.client.gui.container;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.ItemElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.TooltipElement;
-import net.minecraft.client.gui.guidebook.GuidebookScreen;
+import net.minecraft.client.gui.guidebook.GuidebookPageManager;
+import net.minecraft.client.gui.guidebook.ScreenGuidebook;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
-import net.minecraft.client.gui.guidebook.PageManager;
 import net.minecraft.client.gui.guidebook.SearchableGuidebookSection;
-import net.minecraft.client.gui.guidebook.search.SearchPage;
+import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.util.helper.ItemDragHandler;
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
+import net.minecraft.core.block.entity.TileEntityFurnaceBlastFurnace;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.crafting.LookupFuelFurnaceBlast;
 import net.minecraft.core.data.registry.Registries;
@@ -24,31 +23,30 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.menu.*;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.ResultSlot;
-import net.minecraft.core.player.inventory.slot.CreativeSlot;
-import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.player.inventory.slot.SlotResult;
+import net.minecraft.core.player.inventory.slot.SlotCreative;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            GuiScreen, LocalPlayer, RenderHelper, Container,
+//            GuiScreen, PlayerLocal, RenderHelper, Container,
 //            Slot, InventoryPlayer, RenderItem, StringTranslate,
 //            ItemStack, FontRenderer, RenderEngine, PlayerController,
 //            GameSettings, KeyBinding
 
-public abstract class AbstractContainerScreen extends Screen
+public abstract class ScreenContainerAbstract extends Screen
 {
 	public int xSize;
 	public int ySize;
-	public AbstractContainerMenu inventorySlots;
+	public MenuAbstract inventorySlots;
 	TooltipElement tooltipElement;
 	ItemElement itemElement;
 	public ItemDragHandler itemDragHandler;
 
-	public AbstractContainerScreen(final AbstractContainerMenu container)
+	public ScreenContainerAbstract(final MenuAbstract container)
 	{
 		Minecraft mc = Minecraft.getMinecraft(this);
 		xSize = 176;
@@ -95,7 +93,7 @@ public abstract class AbstractContainerScreen extends Screen
 			}
 		}
 
-		final Inventory inventoryplayer = mc.thePlayer.inventory;
+		final ContainerInventory inventoryplayer = mc.thePlayer.inventory;
 		ItemStack grabbedItem = inventoryplayer.getHeldItemStack();
 		if(mc.gameSettings.enableItemDragging.value) {
 			itemDragHandler.drawScreen(xm, ym, partialTick);
@@ -175,17 +173,17 @@ public abstract class AbstractContainerScreen extends Screen
 					String query = "r:"+slot.getItem().getDisplayName()+"!";
 //					removed();
 //					mc.thePlayer.closeScreen();
-					PageManager.searchQuery = SearchQuery.resolve(query);
-					SearchPage.searchField.setText(query);
-					GuidebookScreen.getPageManager().updatePages();
-                    if (!((SearchableGuidebookSection) GuidebookSections.CRAFTING).searchPages(PageManager.searchQuery).isEmpty()) {
-						GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
-                    } else if (!((SearchableGuidebookSection) GuidebookSections.FURNACE).searchPages(PageManager.searchQuery).isEmpty()) {
-						GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.BLAST_FURNACE).searchPages(PageManager.searchQuery).isEmpty()) {
-						GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.TROMMEL).searchPages(PageManager.searchQuery).isEmpty()) {
-						GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.TROMMEL), true);
+					GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
+					GuidebookPageSearch.searchField.setText(query);
+					ScreenGuidebook.getPageManager().updatePages();
+                    if (!((SearchableGuidebookSection) GuidebookSections.CRAFTING).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    } else if (!((SearchableGuidebookSection) GuidebookSections.FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
+					} else if (!((SearchableGuidebookSection) GuidebookSections.BLAST_FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
+					} else if (!((SearchableGuidebookSection) GuidebookSections.TROMMEL).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.TROMMEL), true);
 					}
 					mc.thePlayer.displayGuidebookScreen();
 				}
@@ -196,17 +194,17 @@ public abstract class AbstractContainerScreen extends Screen
 					String query = "u:" + slot.getItem().getDisplayName() + "!";
 //					removed();
 //					mc.thePlayer.closeScreen();
-					PageManager.searchQuery = SearchQuery.resolve(query);
-					SearchPage.searchField.setText(query);
-					GuidebookScreen.getPageManager().updatePages();
-					if (!((SearchableGuidebookSection) GuidebookSections.CRAFTING).searchPages(PageManager.searchQuery).isEmpty()) {
-						GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.FURNACE).searchPages(PageManager.searchQuery).isEmpty()) {
-						GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.BLAST_FURNACE).searchPages(PageManager.searchQuery).isEmpty()) {
-						GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.TROMMEL).searchPages(PageManager.searchQuery).isEmpty()) {
-						GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.TROMMEL), true);
+					GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
+					GuidebookPageSearch.searchField.setText(query);
+					ScreenGuidebook.getPageManager().updatePages();
+					if (!((SearchableGuidebookSection) GuidebookSections.CRAFTING).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+					} else if (!((SearchableGuidebookSection) GuidebookSections.FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
+					} else if (!((SearchableGuidebookSection) GuidebookSections.BLAST_FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
+					} else if (!((SearchableGuidebookSection) GuidebookSections.TROMMEL).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.TROMMEL), true);
 					}
 					mc.thePlayer.displayGuidebookScreen();
 				}
@@ -340,7 +338,7 @@ public abstract class AbstractContainerScreen extends Screen
 		
 		if(mouseButton == 1) action = InventoryAction.CLICK_RIGHT;
 		
-		if(slot instanceof ResultSlot) {
+		if(slot instanceof SlotResult) {
 			// Crafting behavior
 			if(mc.gameSettings.swapCraftingButtons.value) {
 				if(shiftPressed && ctrlPressed) {
@@ -374,7 +372,7 @@ public abstract class AbstractContainerScreen extends Screen
 			}
 		}
 		
-		if(slot instanceof CreativeSlot) {
+		if(slot instanceof SlotCreative) {
 			// Creative slot behavior
 			ItemStack heldItem = mc.thePlayer.inventory.getHeldItemStack();
 			
@@ -400,18 +398,18 @@ public abstract class AbstractContainerScreen extends Screen
 			return;
 		}
 
-		if(inventorySlots instanceof InventoryMenu) {
+		if(inventorySlots instanceof MenuInventory) {
 			if(itemInSlot instanceof IArmorItem) {
-				// Check for instanceof ArmorItem instead of canPutStackInSlot
+				// Check for instanceof ItemArmor instead of canPutStackInSlot
 				// Pumpkins should not go into the armor slot when pressing shift
 				target = 2; // Into the armor slots
 			}
 		}
-		if(inventorySlots instanceof FurnaceMenu) {
+		if(inventorySlots instanceof MenuFurnace) {
 			// Furnace behavior
-			FurnaceMenu furnace = (FurnaceMenu) inventorySlots;
+			MenuFurnace furnace = (MenuFurnace) inventorySlots;
 			
-			boolean isBlastFurnace = furnace.furnace instanceof BlastFurnaceBlockEntity;
+			boolean isBlastFurnace = furnace.furnace instanceof TileEntityFurnaceBlastFurnace;
 			boolean isFuel, isIngredient = false;
 			
 			if(isBlastFurnace) {
@@ -438,19 +436,19 @@ public abstract class AbstractContainerScreen extends Screen
 				target = 2; // Into the fuel slot
 			}
 		}
-		if(inventorySlots instanceof TrommelMenu) {
+		if(inventorySlots instanceof MenuTrommel) {
 			if(LookupFuelFurnace.instance.getFuelYield(clickedItemId) > 0) {
 				target = 2; // Into the fuel slot
 			}else {
 				target = 1; // Into the item slots
 			}
 		}
-		if(inventorySlots instanceof CraftingMenu || inventorySlots instanceof InventoryMenu) {
+		if(inventorySlots instanceof MenuCrafting || inventorySlots instanceof MenuInventory) {
 			// Move items into crafting by holding alt
 			
 			if(altPressed) target = 1; // Into the crafting grid
 		}
-		if(inventorySlots instanceof CreativeInventoryMenu) {
+		if(inventorySlots instanceof MenuInventoryCreative) {
 			// Delete items by holding alt in the creative inventory
 			
 			if(altPressed) {
@@ -467,7 +465,7 @@ public abstract class AbstractContainerScreen extends Screen
 			}
 		}
 		
-		// Inventory Interactions (Grabbed Item)
+		// ContainerInventory Interactions (Grabbed Item)
 		if(slot != null && slot.allowItemInteraction() && grabbedItem != null && grabbedItem.getItem().hasInventoryInteraction()) {
 			if(mouseButton == 1) {
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.INTERACT_GRABBED, new int[] {slot.index}, mc.thePlayer);
@@ -475,7 +473,7 @@ public abstract class AbstractContainerScreen extends Screen
 			}
 		}
 		
-		// Inventory Interactions (Clicked Item)
+		// ContainerInventory Interactions (Clicked Item)
 		if(slot != null && stackInSlot != null && slot.allowItemInteraction() && stackInSlot.getItem().hasInventoryInteraction()) {
 			if(mouseButton == 1) {
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.INTERACT_SLOT, new int[] {slot.index}, mc.thePlayer);
